<?php

class bdNoConvoEmail_Installer
{
	/* Start auto-generated lines of code. Change made will be overwriten... */

	protected static $_tables = array();
	protected static $_patches = array(
		array(
			'table' => 'xf_conversation_recipient',
			'field' => 'bdnoconvoemail_disabled',
			'showTablesQuery' => 'SHOW TABLES LIKE \'xf_conversation_recipient\'',
			'showColumnsQuery' => 'SHOW COLUMNS FROM `xf_conversation_recipient` LIKE \'bdnoconvoemail_disabled\'',
			'alterTableAddColumnQuery' => 'ALTER TABLE `xf_conversation_recipient` ADD COLUMN `bdnoconvoemail_disabled` TINYINT(4) UNSIGNED NOT NULL DEFAULT \'0\'',
			'alterTableDropColumnQuery' => 'ALTER TABLE `xf_conversation_recipient` DROP COLUMN `bdnoconvoemail_disabled`',
		),
	);

	public static function install($existingAddOn, $addOnData)
	{
		$db = XenForo_Application::get('db');

		foreach (self::$_tables as $table)
		{
			$db->query($table['createQuery']);
		}

		foreach (self::$_patches as $patch)
		{
			$tableExisted = $db->fetchOne($patch['showTablesQuery']);
			if (empty($tableExisted))
			{
				continue;
			}

			$existed = $db->fetchOne($patch['showColumnsQuery']);
			if (empty($existed))
			{
				$db->query($patch['alterTableAddColumnQuery']);
			}
		}
		
		self::installCustomized($existingAddOn, $addOnData);
	}

	public static function uninstall()
	{
		$db = XenForo_Application::get('db');

		foreach (self::$_patches as $patch)
		{
			$tableExisted = $db->fetchOne($patch['showTablesQuery']);
			if (empty($tableExisted))
			{
				continue;
			}

			$existed = $db->fetchOne($patch['showColumnsQuery']);
			if (!empty($existed))
			{
				$db->query($patch['alterTableDropColumnQuery']);
			}
		}

		foreach (self::$_tables as $table)
		{
			$db->query($table['dropQuery']);
		}

		self::uninstallCustomized();
	}

	/* End auto-generated lines of code. Feel free to make changes below */

	public static function installCustomized($existingAddOn, $addOnData)
	{
		// customized install script goes here
	}

	public static function uninstallCustomized()
	{
		// customized uninstall script goes here
	}
	
}